/*
	LUSScreenSaver Plugin LUSSSExeKicker ( Executable File Kicker )
	Copyright (C) 2003 ONO,Masayuki.<mono101@skill-engineering.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "LUSSSExeKicker.h"
#include "LUSSSExeKickerSetting.h"

#include <qpe/config.h>
#include <qpe/global.h>
#include <stdlib.h>
#include <qfile.h>
#include <qfileinfo.h>

#include <qtextcodec.h>
#define _T(str) QTextCodec::codecForLocale()->toUnicode(str)

LUSSSExeKicker::LUSSSExeKicker()
: ref(0)
{
}

LUSSSExeKicker::~LUSSSExeKicker(  )
{
}

QString LUSSSExeKicker::Name()
{
	return _T( "¾ץ¹ԥ꡼󥻡" );
}

QString LUSSSExeKicker::Version()
{
	return _T( "1.0.0" );
}

QString LUSSSExeKicker::Comment()
{
	return _T( "ϻ/λ˥뤹륹ץ\n¹ԷեǤޤ" );
}

void LUSSSExeKicker::Setting()
{
	LUSSSExeKickerSetting dlg( NULL, _T("ɽ"), TRUE, NULL );
	dlg.exec();
}

QWidget* LUSSSExeKicker::Init( int nMode )
{
	switch( nMode )
	{
	case LUS_NORMAL:
	case LUS_PREVIEW:
	default:
		break;
	}
	
	return NULL;
}

void LUSSSExeKicker::Start()
{
	Config cfg( "LUSScreenSaver" );
	cfg.setGroup( "LUSSSExeKicker" );
	QString sKick = cfg.readEntry( "StartApp" );
	
	if ( QFile::exists( sKick ) )
	{
		QFileInfo fi( sKick );
		if ( fi.isExecutable() )
		{
			switch ( cfg.readNumEntry( "Func", 0 ) )
			{
			case 0:
				Global::invoke( sKick );
				break;
			case 1:
				Global::execute( sKick );
				break;
			case 2:
				system( sKick.latin1() );
				break;
			default:
				break;
			}
		}
	}
}

void LUSSSExeKicker::Stop()
{
	Config cfg( "LUSScreenSaver" );
	cfg.setGroup( "LUSSSExeKicker" );
	QString sKick = cfg.readEntry( "StopApp" );
	
	if ( QFile::exists( sKick ) )
	{
		QFileInfo fi( sKick );
		if ( fi.isExecutable() )
		{
			switch ( cfg.readNumEntry( "Func", 0 ) )
			{
			case 0:
				Global::invoke( sKick );
				break;
			case 1:
				Global::execute( sKick );
				break;
			case 2:
				system( sKick.latin1() );
				break;
			default:
				break;
			}
		}
	}
}

QRESULT LUSSSExeKicker::queryInterface(const QUuid& uuid,
	QUnknownInterface** iface)
{
	*iface = 0;
	if(uuid == IID_QUnknown)
	{
		*iface = this;
	}
	else if ( uuid == IID_LUSScreenSaver )
	{
		*iface = this;
	}

	if(*iface)
	{
		(*iface)->addRef();
	}

	return QS_OK;
}

Q_EXPORT_INTERFACE()
{
	Q_CREATE_INSTANCE( LUSSSExeKicker )
}
